local last_ready = {}
local msg_prog = 0-1
local last_update = 0
local missionFollowers = {}
local frame = CreateFrame("FRAME")
local soundList = {
	["Dreamgrove Treants"] = {
		ready = 34166, added = 34167, what = 34166
	},
	["Druids of the Claw"] = {
		ready = 6209, added = 6210, attack = 6215, what = 6211
	},
	["Keepers of the Grove"] = {
		ready = 24967, added = 24958, attack = 26493, what = 20811
	},
	["Daughters of Cenarius"] = {
		ready = 6328, added = 6328, what = 6330
	}
}
local nextUpdate = 0
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("GARRISON_FOLLOWER_ADDED")
frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" and ... == "TheSleeperHasAwakened" then
		local t_gfs = C_Garrison.GetFollowerShipments
		local l_cggfs = C_Garrison.GetFollowerShipments
		hooksecurefunc(C_Garrison, "GetFollowerShipments", function(...)
			local ret = l_cggfs(...)
			for k, v in pairs(ret) do
				local fol = {C_Garrison.GetLandingPageShipmentInfoByContainerID(v)}
				--print(unpack(fol))
				local creation = fol[6]
				local duration = fol[7]
				if creation > 0 and duration > 0 then
					local nu = creation + duration + 5
					if nu < nextUpdate or nextUpdate == 0 then
						nextUpdate = nu
					end
				end
				if last_ready[fol[1]] == nil then
					last_ready[fol[1]] = fol[4]
				end
				if fol[4] > last_ready[fol[1]] then
					UIErrorsFrame:AddMessage(fol[4] .. " " .. fol[1] .. " ready", 0, 0.7, 1)
					msg_prog = 0
					local sl = soundList[fol[1]]
					if sl then
						if sl.ready then
							PlaySoundKitID(sl.ready)
						end
					end
				end
				last_ready[fol[1]] = fol[4]
			end
			--return ret
		end)
		local t_rffm = C_Garrison.RemoveFollowerFromMission
		hooksecurefunc(C_Garrison, "RemoveFollowerFromMission", function(...)
			--print(...)
			local _, id = ...
			local n = C_Garrison.GetFollowerName(id)
			if missionFollowers[n] then
				missionFollowers[n] = missionFollowers[n] - 1
				if missionFollowers[n] == 0 then
					missionFollowers[n] = nil
				end
			end
			--return t_rffm(...)
		end)
		local t_aftm = C_Garrison.AddFollowerToMission
		hooksecurefunc(C_Garrison, "AddFollowerToMission", function(...)
			--print(...)
			local _, id = ...
			local n = C_Garrison.GetFollowerName(id)
			if soundList[n] then
				if soundList[n].what then
					PlaySoundKitID(soundList[n].what)
				end
			end
			if missionFollowers[n] == nil then
				missionFollowers[n] = 0
			end
			missionFollowers[n] = missionFollowers[n] + 1
			--return t_aftm(...)
		end)
		local t_sm = C_Garrison.StartMission
		hooksecurefunc(C_Garrison, "StartMission", function(...)
			--print(...)
			for k, v in pairs(missionFollowers) do
				missionFollowers[k] = nil
				if soundList[k] then
					if soundList[k].attack then
						PlaySoundKitID(soundList[k].attack)
						break
					end
				end
			end
			missionFollowers = {}
			--return t_sm(...)
		end)
--[[
		local t_glpr = GarrisonLandingPageReport_GetShipments
		GarrisonLandingPageReport_GetShipments = function(...)
			print("test")
			t_glpr(...)
			local buildings = C_Garrison.GetBuildings(LE_GARRISON_TYPE_7_0)
			for k, v in pairs(buildings) do
				if v.buildingID then
					local name, _, cap, rdy, tot, dur, tls, _, _, _, _ = C_Garrison.GetLandingPageShipmentInfo(v.buildingID)
					print(name, cap, rdy, tot, dur, tls)
				end
			end
			local fols = C_Garrison.GetFollowerShipments(LE_GARRISON_TYPE_7_0)
			for k, v in pairs(fols) do
				local fol = {C_Garrison.GetLandingPageShipmentInfoByContainerID(v)}
				print(unpack(fol))
			end
		end]]
	elseif event == "GARRISON_FOLLOWER_ADDED" then
		local list = {...}
		local name = list[2]
		local sl = soundList[name]
		if sl then
			if sl.added then
				PlaySoundKitID(sl.added)
			end
		end
	end
end)
local ela = 0
local ela1 = 24*60
frame:SetScript("OnUpdate", function(self, elapsed)
	ela = ela + elapsed
	if ela > 20 then
		ela = 0
		C_Garrison.GetFollowerShipments(LE_GARRISON_TYPE_7_0)
	end
	ela1 = ela1 +elapsed
	if ela1 > 25*60 then
		ela1 = 0
		C_Garrison.RequestLandingPageShipmentInfo()
		last_update = time()
	end
	if time() > nextUpdate and nextUpdate > 0 then
		nextUpdate = 0
		C_Garrison.RequestLandingPageShipmentInfo()
		--print("nextUpdate")
	end
	if msg_prog > -1 then
		msg_prog = msg_prog + elapsed
		if msg_prog > 1 then
			msg_prog = -1
		end
	end
end)